<?php

namespace Treewec\Admin;

/**
 * Test class for FileRenameForm.
 * Generated by PHPUnit on 2012-06-23 at 14:05:55.
 * @group admin_fileform
 */
class FileHiddenFormTest extends \PHPUnit_Framework_TestCase {

    private $formObject;

    protected function setUp() {
        $_POST['submit'] = 'submit';
    }

    public function testVisibilityChange() {
        // change to hidden
        $this->changeVisibilityInTempDir();
        // change back to public
        $this->changeVisibilityInTempDir();
    }
    
    private function changeVisibilityInTempDir() {        
        $iterator = new \Treewec\DirectoryIterators\DirectoryIterator(TEMP_FILEDIR);
        $iterator->next();// skip root
        while ($iterator->hasNext()) {
            $currentFile = $iterator->next();
            if ($currentFile->splFileInfo->getFilename() == 'dir.order') {
                continue;
            }
            $filePath = $currentFile->splFileInfo->getPathname();

            # FAIL
            // visibility must be boolean
            $this->assertVisibilityChange($filePath, null, false);
            $this->assertVisibilityChange($filePath, array(), false);
            // visibility must be different            
            $this->assertVisibilityChange($filePath, !\Treewec\FileSystem\Filename::isHidden($currentFile->splFileInfo->getFilename()), false);

            # OK
            // visibility is negation of current visibility
            $this->assertVisibilityChange($filePath, \Treewec\FileSystem\Filename::isHidden($currentFile->splFileInfo->getFilename()), true);
        }
    }

    private function assertVisibilityChange($filePath, $visibility, $isChangeSuccessfull) {
        $this->formObject = new FileHiddenForm('submit', true);
        $this->formObject->setSuccessAction(FormSuccessAction::NOTHING);
        $this->formObject->setFilePath($filePath);
        if (is_bool($visibility)) {
            $_POST['visibility'] = $visibility ? '1' : '0';
        } else {
            $_POST['visibility'] = $visibility;
        }
        $this->formObject->process();
        parent::assertTrue($this->formObject->isValid() == $isChangeSuccessfull);
        parent::assertTrue(file_exists($filePath) != $isChangeSuccessfull);
    }

}

?>